<template>
  <VCard :elevation="6" :min-height="400">
    <VBottomNavigation v-model="bottomNav" class="elevation-0" shift>
      <VBtn>
        <span>Editor</span>
        <VIcon>mdi-comment-edit</VIcon>
      </VBtn>

      <VBtn>
        <span>View</span>
        <VIcon>mdi-code-json</VIcon>
      </VBtn>
    </VBottomNavigation>
    <VDivider />
    <VCardText>
      <EditorJsonChatBot v-if="bottomNav === 0" v-model="form" />
      <template v-else>
        <div class="text-right mb-2">
          <VTooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <VBtn icon v-bind="attrs" v-on="on" @click="$refs.file.click()">
                <VIcon>mdi-cloud-braces</VIcon>
              </VBtn>
            </template>
            <span>Upload JSON</span>
          </VTooltip>
          <VTooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <VBtn icon v-bind="attrs" v-on="on" @click="downloadFile">
                <VIcon>mdi-download</VIcon>
              </VBtn>
            </template>
            <span>Download JSON</span>
          </VTooltip>
        </div>
        <JsonViewer :value="form" :expand-depth="5" copyable boxed sort />

        <!-- input-upload-json -->
        <input
          v-show="false"
          ref="file"
          type="file"
          accept="application/JSON"
          @change="onFileChange($event.target.files)"
        />
      </template>
    </VCardText>
  </VCard>
</template>

<script>
import { createDownloadFile, readFile } from '@/utils'

export default {
  components: {
    EditorJsonChatBot: () => import('@/components/EditorJsonChatBot.vue'),
  },

  data: () => ({
    bottomNav: 0,
    form: [],
  }),

  methods: {
    downloadFile() {
      const data = new Blob([JSON.stringify(this.form)], {
        type: 'text/plain;charset=utf-8',
      })
      createDownloadFile(data, 'data.json')
    },

    async onFileChange(files) {
      const file = files[0]
      const data = await readFile(file)

      this.$refs.file.value = ''
      this.form = JSON.parse(data)
    },
  },
}
</script>
